{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 01-10-2001
  Versión actual: 1.0.1
  Fecha versión actual: 24-10-2001
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
    24-10-2001    Se ha eliminado el campo 'codigo de pedido' porque ya no
                  existe en la cabecera de la factura. 
===============================================================================
}

unit BuscarFacturaProveedor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RDXFRAME, RdxBotones, ExtCtrls, StdCtrls, RdxCampos, RdxTitulos,
  RdxPaneles, RdxBarras, RdxFrameFacturasProveedor;

type
  TfrBuscarFacturaProveedor = class(TRdxFrameFacturasProveedor)
    brBuscar: TRdxBarraInferior;
    bBuscar: TRdxBoton;
    bCerrar: TRdxBoton;
    pnlScroll: TRdxScrollPanel;
    cBuscarProveedor: TRdxCabecera;
    Label3: TLabel;
    eNumCodFacProv: TLabel;
    eCodigo: TLabel;
    Label2: TLabel;
    eNombre: TLabel;
    Codigo: TRdxEdit;
    CodFacturaProv: TRdxEdit;
    CodigoProveedor: TRdxEdit;
    NIFCIF: TRdxEdit;
    Nombre: TRdxEdit;
    procedure bBuscarClick(Sender: TObject);
    procedure bCerrarClick(Sender: TObject);
  private
    procedure RecogerDatos;
  protected
    procedure BuscarFactura; override;
    function CloseFrame : boolean; override;    
  public
    constructor Create(AOwner : TComponent); override;
    
  end;

var
  frBuscarFacturaProveedor: TfrBuscarFacturaProveedor;

implementation
{$R *.DFM}

{ TfrBuscarFacturaProveedor }

uses
  Tipos, DB, Mensajes, StrFunc, Configuracion, Literales;

var
  Campos : String;
  Valores : Variant;
  Contador : Integer;

procedure TfrBuscarFacturaProveedor.BuscarFactura;
var
  Respuesta : integer;
  Resultado : Boolean;
begin
  if Contador <> -1 then begin
    TablaFacturasProveedor.DisableControls;

    if Contador = 0 then
      Resultado := TablaFacturasProveedor.LocateNext(Campos, Valores[Contador], [loCaseInsensitive, loPartialKey])
    else
      Resultado := TablaFacturasProveedor.LocateNext(Campos, Valores, [loCaseInsensitive, loPartialKey]);
    if (Resultado = false) then
    begin
        Respuesta := VerMensajePregunta(msgIrInicio);
        case Respuesta of
          IDYES: TablaFacturasProveedor.First;
        end;
    end;
    TablaFacturasProveedor.EnableControls;
  end;
end;

constructor TfrBuscarFacturaProveedor.Create(AOwner: TComponent);
begin
  if not (AOwner is TRdxFrameFacturasProveedor) then
    exit;
  inherited Create(AOwner);
  Entidad := entFacturaProveedor;
  ConfigurarFrame(Self, Self.Entidad);

  Contador := -1;
  Campos := '';
  Valores := VarArrayOf([null, null, null, null, null, null]);

  TablaFacturasProveedor := (AOwner as TRdxFrameFacturasProveedor).TablaFacturasProveedor;
  with TablaFacturasProveedor do begin
    Codigo.MaxLength := FieldByName('CODIGO').Size;
    CodFacturaProv.MaxLength := FieldByName('CODIGOFACTURA').Size;
    Nombre.MaxLength := FieldByName('NOMBRE').Size;
    CodigoProveedor.MaxLength := FieldByName('CODIGOPROVEEDOR').Size;
    NIFCIF.MaxLength := FieldByName('NIFCIF').Size;
  end;
end;

procedure TfrBuscarFacturaProveedor.RecogerDatos;
begin
  Campos := '';
  Contador := -1;

  if not EsCadenaVacia(Codigo.Text) then
  begin
    Contador := Contador + 1;
    Campos := Campos + 'CODIGO';
    Valores[Contador] := Trim(Codigo.Text);
  end;

  if not EsCadenaVacia(CodFacturaProv.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'CODIGOFACTURA';
    Valores[Contador] := Trim(CodFacturaProv.Text);
  end;

  if not EsCadenaVacia(CodigoProveedor.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'CODIGOPROVEEDOR';
    Valores[Contador] := Trim(CodigoProveedor.Text);
  end;

  if not EsCadenaVacia(Nombre.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'NOMBRE';
    Valores[Contador] := Trim(Nombre.Text);
  end;

  if not EsCadenaVacia(NIFCIF.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'NIFCIF';
    Valores[Contador] := Trim(NIFCIF.Text);
  end;
end;

procedure TfrBuscarFacturaProveedor.bBuscarClick(Sender: TObject);
begin
  RecogerDatos;
  if Contador <> -1 then
    BuscarFactura
  else
    VerMensaje(msgNoParametros);
end;

procedure TfrBuscarFacturaProveedor.bCerrarClick(Sender: TObject);
begin
  inherited;
  CloseFrame;
end;

function TfrBuscarFacturaProveedor.CloseFrame: boolean;
begin
  FCodigoFactura := TablaFacturasProveedor.FieldByName('CODIGO').AsString;
  Result := inherited CloseFrame;
end;

end.
